# function subroutine to for crude localization using centre of mass#
import numpy as np
import scipy.ndimage as ndimage
import scipy.ndimage.filters as filters


# defining the PSF detector 
def rough_position_estimator(data,threshold,neighborhood_size):
	'''
	parameter data: input image array
	parameter threshold: a number >0
	parameter neighbourhood size: neighouring pixels 4 or 9 or any number
	returns: coordinates of the detected PSFs
	'''
	threshold=threshold
	data_max = filters.maximum_filter(data, neighborhood_size)
	maxima = (data == data_max)
	data_min = filters.minimum_filter(data, neighborhood_size)
	diff = ((data_max - data_min) > threshold)
	
	maxima[diff == 0] = 0

	labeled, num_objects = ndimage.label(maxima)
	coordinates_xy = np.array(ndimage.center_of_mass(data, labeled, range(1, num_objects+1)))
	
	return coordinates_xy


# defining a function to detect the PSFs using COM
def Detection(image,threshold,neighborhood_size):

	images = image.astype(np.uint8)
		
	params=np.zeros(2)
	molecule_x = []
	molecule_y = []

	coordinates = rough_position_estimator(images, threshold, neighborhood_size)
		
	# if coordinates are detected, append the x and y to respective lists
	if coordinates.size>0:
		y, x = coordinates.T
		molecule_x.append(x)
		molecule_y.append(y)
		
				
	params=molecule_x,molecule_y

	return params

